
Redmine - Patch #24839

Minor performance improvement - Replace count by exists?

2017-01-16 14:23 - Vincent Robert

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: Performance Estimated time: 0.00 hour

Target version: 3.4.0   

Description

When checking to see if a query returns any records, we should use the ActiveRecord exists? method instead of count.

Here is an example in the versions/show.html.erb file:

diff --git a/app/views/versions/show.html.erb b/app/views/versions/show.html.erb

index 82bd572..fc22a9f 100644

--- a/app/views/versions/show.html.erb

+++ b/app/views/versions/show.html.erb

@@ -32,7 +32,7 @@

 <% end %>

 <div id="status_by">

-<%= render_issue_status_by(@version, params[:status_by]) if @version.fixed_issues.count > 0 %>

+<%= render_issue_status_by(@version, params[:status_by]) if @version.fixed_issues.exists? %>

 </div>

 </div>

 
If we compare the generated queries with PostgreSQL: 

SELECT  1 AS one FROM "issues" WHERE "issues"."fixed_version_id" = ??? LIMIT 1;

should be faster than

SELECT COUNT(*) FROM "issues" WHERE "issues"."fixed_version_id" = ???;

Related issues:

Related to Redmine - Patch #26728: count > 0 vs exists? Closed

Associated revisions

Revision 16210 - 2017-01-16 19:11 - Jean-Philippe Lang

Use exists? instead of count (#24839).

Revision 16211 - 2017-01-16 19:12 - Jean-Philippe Lang

Use exists? instead of count (#24839).

Patch by Vincent Robert and Go MAEDA.

History

#1 - 2017-01-16 15:42 - Go MAEDA

- File use-exists-instead-of-count.diff added

Thank you for the patch.

I found three more count which can be replaced with exists?. This is an updated patch: use-exists-instead-of-count.diff

Although .count > 0 can be found in app/views/imports/show.html.erb too, I have not changed because of cache efficiency (exactly the same query

will be performed just after them).

#2 - 2017-01-16 15:57 - Go MAEDA

- File deleted (use-exists-instead-of-count.diff)
#3 - 2017-01-16 15:58 - Go MAEDA

- File use-exists-instead-of-count.diff added

Excluded app/models/project.rb from the patch because of cache efficiency.

#4 - 2017-01-16 19:13 - Jean-Philippe Lang

- Status changed from New to Closed

- Assignee set to Jean-Philippe Lang

- Target version set to 3.4.0

Committed, thanks.

#5 - 2018-07-01 06:48 - Go MAEDA

- Related to Patch #26728: count > 0 vs exists? added

Files

use-exists-instead-of-count.diff 1.54 KB 2017-01-16 Go MAEDA
